<?php defined('SYSPATH') or die('No direct script access.');

abstract class SortingOptions { //extends SplEnum {  // todo: think about usage & file system
    //const __default = self::Name;

    const Name = 0;
    const Grade = 1;
    const Group = 2;
}

class Controller_Handler_AdmStudents extends Controller_Handler
{
        public function before() {
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }

        public function action_createStudent()
        {
            $response['success'] = false;
            $this->post
                    ->rule('firstName', 'not_empty')
                    // ->rule('firstName', 'alpha_dash', array(':value', TRUE))
                    // ->rule('secondName', 'not_empty')
                    // ->rule('secondName', 'alpha_dash', array(':value', TRUE))
                    ->rule('lastName', 'not_empty')
                    // ->rule('lastName', 'alpha_dash', array(':value', TRUE))
                    ->rule('gradeNum', 'not_empty')
                    ->rule('gradeNum', 'digit')
                    ->rule('groupNum', 'not_empty')
                    ->rule('groupNum', 'digit')
                    ->rule('facultyID', 'not_empty')
                    ->rule('facultyID', 'digit');
            if($this->post['gradeNum'] == 0)
            {
                $this->post->error('gradeNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post['groupNum'] == 0)
            {
                $this->post->error('groupNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post['facultyID'] == 0)
            {
                $this->post->error('facultyID', 'not_empty');
                $response['success'] = false;
            }
            if($this->post->check())
            {
                $code = $this->_createStudent(
                        $this->post['lastName'],
                        $this->post['firstName'],
                        $this->post['secondName'],
                        $this->post['gradeNum'],
                        $this->post['groupNum'],
                        $this->post['facultyID']);
                if($code != -1)
                {
                    $response['success'] = true;
                    $response['code'] = $code;
                }
                else {
                    $response['success'] = false;
                }
            }
            else
            {
                $response['success'] = false;
                $response['messages'] = $this->post->errors();
            }
            $this->response->body(json_encode($response));
        }
        
        protected function _createStudent($lastName, $firstName, $secondName, $gradeID, $groupNum, $facultyID)
        {
            $activationCode = Account::instance()->createStudent($lastName, $firstName, $secondName, $gradeID, $groupNum, $facultyID);
            return $activationCode;
        }
        
        public function action_getGroups()
        {
            $facultyID = $this->post['facultyID'];
            $gradeID = $this->post['gradeNum'];
            if(($facultyID && $gradeID) != 0)
            {
                $groups = Model_Faculty::with($facultyID)->getGroups($gradeID);
                $groupsHandled = array(); $i = $j = $id = 0;
                foreach($groups as $row)
                {
                    if($id != $row['SpecID'])
                    {
                        $i++; $j = 0;
                        $id = $row['SpecID'];
                    }
                    $j++;
                    if (is_null($row['SpecName'])) 
                    	$groupsHandled[$i]['SpecName'] = "<без специализации>";
                    else
                    	$groupsHandled[$i]['SpecName'] = $row['SpecName'];
                    $groupsHandled[$i]['Groups'][$j]['ID'] = $row['ID'];
                    $groupsHandled[$i]['Groups'][$j]['Num'] = $row['GroupNum'];
                }
                $this->response->body(json_encode($groupsHandled));
            }
        }

        public function action_getStudentsList($option = SortingOptions::Name)
        {
            $from = isset($this->get['dean']) ? 'dean_office' : 'admin';
            $twig = Twig::factory($from . '/students/handler/listOutput');

            $success = false;
            $facultyID = $this->post['facultyID'];
            $gradeID = $this->post['gradeID'];
            $groupID = $this->post['groupID'];

            $this->post-> rule('facultyID', 'not_empty')
                -> rule('facultyID', 'digit')
                -> rule('gradeID', 'not_empty')
                -> rule('gradeID', 'digit')
                -> rule('groupID', 'not_empty')
                -> rule('groupID', 'digit');

            if($this->post->check()) {
                $result = Model_Students::byFaculty($facultyID , $gradeID, $groupID);
                if (!empty($result)) {
                    $twig->List = $result;
                    $success = true;
                }

            }
            //$this->response->body(json_encode($data));
            $twig->Success = $success;
            $this->response->body($twig);
        }

        public function action_getStudentsByStudyGroup()
        {
            $groupID = $this->post['studyGroupID'];
            if($groupID != 0)
            {
                $twig = Twig::factory('admin/students/handler/listOutput');
                $twig->List = Model_Students::byStudyGroup($groupID);
                $this->response->body($twig);           
            }
        }

        /** @deprecated */
        public function action_getStudentsByFaculty()
        {
            $facultyID = $this->post['facultyID'];
            if($facultyID != 0)
            {
                $twig = Twig::factory('admin/students/handler/listOutput');
                // (Grade, Group) = (0,0), to ignore (search all students)
                $twig->List = Model_Students::byFaculty($facultyID, 0, 0);
                $this->response->body($twig);           
            }
        }

    public function action_giveLeave() {
        // fixme
        $id = (int) $this->get['id'];
        Model_Student::load($id)
            ->toAcademicLeave();
    }

    public function action_stopLeave() {
        // fixme
        $id = (int) $this->get['id'];
        //Model_Student::load($id)
        //    ->attach()
    }
}